




clear;
close all;

addpath('D:\COMPUTATION\MATLAB\PI');

% READ AND TRIM B1MAPS
load ../uSENSE_AP/B1MAPS;

mask = double( sum(abs(B1MAPS),3) > 0 );
ind = find( mask );
[ indx indy ] = ind2sub( size(mask),ind );

xmin = min(indx); xmax = max(indx);
ymin = min(indy); ymax = max(indy);

B1MAPS = B1MAPS( xmin:xmax , ymin:ymax , : );


[ nx ny ncoils ] = size(B1MAPS);
nx0 = nx;
ny0 = ny;

B1MAPS = reshape( B1MAPS,nx,ny,1,ncoils );


% LOSS MATRIX
LOSS = reshape( read_ddata( '../fields/LOSS_N_2500.dat',-1 ),ncoils,2*ncoils );
LOSS = LOSS( :,1:2:end ) + 1j*LOSS( :,2:2:end );

% scale LOSS for num stability (does not change the GFAC result)
LOSS = LOSS / max(abs(LOSS(:)));

US_fac = [ 2 3  4  5  6  7  8 ];
New_ny = ceil( nx0 ./ US_fac ) .* US_fac;  % make sure the new acc dim is divisible by US_fac

f = figure;
Nimg1 = ceil( sqrt( size(US_fac,2) ) );

Nimg2 = Nimg1;
if (Nimg2-1)*Nimg1 >= size(US_fac,2)
    Nimg2 = Nimg1 - 1;
end

y = [];
f2 = figure;

for ii = 1 : size(US_fac,2)
    
    fprintf('SENSE 1x%d\n',US_fac(ii));
    
    if New_ny(ii) ~= nx0
        XX = linspace( 0,1,nx0 );
        YY = linspace( 0,1,ny0 );
        ZZ = linspace( 0,1,ncoils );
        
        XX2 = linspace( 0,1,New_ny(ii) );
        YY2 = linspace( 0,1,ny0 );
        ZZ2 = linspace( 0,1,ncoils );
        
        [ XXX2 YYY2 ZZZ2 ] = ndgrid( XX2 , YY2 , ZZ2 );

        B1MAPS2 = reshape( interpn( XX , YY , ZZ , squeeze(B1MAPS) , XXX2 , YYY2 , ZZZ2 ) , New_ny(ii) , ny0 , 1, ncoils );
    else
        B1MAPS2 = B1MAPS;
    end

    [nx ny nz ncoils] = size(B1MAPS2);
    US = zeros(nx,ny);
    US( 1:US_fac(ii):end , : ) = 1;
    IMG = ones( nx,ny,1,ncoils );
    
    [IMG_rec GFAC] = pi_sense( IMG , B1MAPS2 , LOSS , US , 1);

    eval( sprintf( 'save GFAC_1x%d.mat GFAC;',US_fac(ii) ) );
    
    
    figure(f); subplot( Nimg1,Nimg2,ii ); 
    imagesc(GFAC); axis image off; colorbar; 
    drawnow;
    
    y = [ y;max(GFAC(:)) ];
    
    figure(f2);
    bar( US_fac(1:ii) , y );
    xlabel('R');
    ylabel('max G');
    drawnow;

end




























